###############################################
## A simple pong by Mattéo Bouliteau 06/2020 ##
###############################################

#
# Propriétaire du programme : Mattéo Bouliteau
# Conçu le 16 Juin 2020
#
# Ce programme peut être exécuté librement, utilisé et partagé.
# Il est impossible de le revendre, s'en prétendre le propriétaire ou le modifier, ni partiellement, ni totalement.
#

## Bibliothèques ##
from tkinter import *
import time
from random import *
import ftplib as ftp

## Fonctions ##
# Quitter le jeu
def quitter():
    window.destroy()

# Envoyer les données de la partie au serveur web
def sendDatas() :
    # Connexion à la base de données
    host = "ftp.boma0924.odns.fr" # Server Host
    user = "score@ponggame.matteo.bouliteau.fr" # Username
    password = "Wi5mv^nb~}^~=G3ucd" # Password
    db = ftp.FTP(host,user,password) # Connexion
    
    # Création d'un répertoire pour le score
    score_directory = db.mkd(str(score))
    print(score_directory)
    
    # Déconnexion au serveur FTP
    db.quit()

# Déplacer la raquette vers la droite
def right(event) :
    if can.coords(raquette)[2] < canvas_donnees['width'] :
        can.move(raquette, 20, 0)

# Déplacer la raquette vers la gauche
def left(event) :
    if can.coords(raquette)[2] > 100 :
        can.move(raquette, -20, 0)
        
# Déplacer la raquette vers la droite rapidement
def extraRight(event) :
    if can.coords(raquette)[2] < canvas_donnees['width'] :
        can.move(raquette, 80, 0)

# Déplacer la raquette vers la gauche rapidement
def extraLeft(event) :
    if can.coords(raquette)[2] > 100 :
        can.move(raquette, -80, 0)

# Accélerer la balle
def accelerate() :
    # Variables des directions de la balle
    global direction_x, direction_y, neutre_direction, coeff_speed
    
    # Gestion du coefficient de vitesse
    if neutre_direction < 18 :
        coeff_speed = 1.03
    
    elif neutre_direction >= 18 :
        coeff_speed = 1.005
    
    # Mise à jour de la vitesse
    neutre_direction *= coeff_speed
    direction_x *= coeff_speed
    direction_y *= coeff_speed

# Faire rebondir la balle
def balle_rebond() :
    # Variables des directions de la balle, des contacts avec les murs et du score
    global direction_x, direction_y, score, touch_mur
    
    # Si on touche un angle
    if can.coords(balle)[2] >= canvas_donnees['width'] and can.coords(balle)[3] <= 20 or can.coords(balle)[2] <= 20 and can.coords(balle)[3] <= 20 :
        direction_x, direction_y = -direction_x, -direction_y
        touch_mur = 1
        accelerate()

    # Si on touche à l'horizontal
    elif can.coords(balle)[2] >= canvas_donnees['width'] or can.coords(balle)[2] <= 20 :
        direction_x = -direction_x
        touch_mur = 1
        accelerate()
    
    # Si on touche le haut
    elif can.coords(balle)[3] <= 20 :
        direction_y = -direction_y
        touch_mur = 1
        accelerate()
    
    # Si on touche la zone interdite
    elif can.coords(balle)[3] >= canvas_donnees['height'] :
        continuer = 0
        can.destroy()
        labelPerdu = Label(window,padx=50,pady=20,text='Perdu ! Vous avez marqué un total de ' + str(score) + ' points !')
        labelPerdu.grid(row=0,column=0)
        # On envoie les données au serveur
        sendDatas()
        
    # Si on est au niveau de la raquette
    elif can.coords(balle)[3] >= can.coords(raquette)[3] - 10 and can.coords(balle)[3] <= can.coords(raquette)[3] + 10 :
        if can.coords(balle)[2] >= can.coords(raquette)[2] - 100 and can.coords(balle)[2] <= can.coords(raquette)[2] + 10 :
            # Si la balle a touché au moins un mur entre temps
            if touch_mur == 1 :
                direction_y = -direction_y
                score += 1
                touch_mur = 0
                accelerate()

# Déplacement de la balle
def balle_move() :
    # On assure un rebond si nécessaire
    balle_rebond()
    
    # Mouvement
    can.move(balle, direction_x, direction_y)
    window.update()
    time.sleep(0.03)

## Main ##
window = Tk()
window.title('Simple Pong Game by Mattéo Bouliteau')

# Données du jeu
score = 0
touch_mur = 1
continuer = 1

# Affichage du tableau de score
label = Label(window,padx=50,pady=20,text='Votre score : ' + str(score) + ' points')
label.grid(row=0,column=0)

# Données du canvas
canvas_donnees = {}
canvas_donnees['height'] = 500;
canvas_donnees['width'] = 800;
# Création du canvas
can = Canvas(window,background='#333333', width=canvas_donnees['width'], height=canvas_donnees['height'])
can.grid(row=1,column=0)

# Bouton fin de partie
button = Button(window,text = 'Quitter le jeu', command=quitter)
button.grid(row=2,column=0)

#Création de la balle
balle_position_random = randint(0, canvas_donnees['width'] - 20)
balle = can.create_oval(balle_position_random, 10, balle_position_random + 20, 30, width=1, outline="#e83e57", fill="#e83e57")

# Création de la raquette
raquette = can.create_rectangle(canvas_donnees['width'] / 2 - 50, canvas_donnees['height'] - 20, canvas_donnees['width'] / 2 + 50, canvas_donnees['height'] - 10, width=1, outline="#dddddd", fill="#dddddd")

# Données de la balle
direction_x = 8
direction_y = 8
neutre_direction = 8

# Tant que l'utilisateur n'arrête pas le jeu, on déplace la balle
while continuer == 1 :
    # Mouvement de la balle
    balle_move()
    # Repérage d'utilisation de la raquette
    can.bind_all('<Right>', right)
    can.bind_all('<Left>', left)
    can.bind_all('<Shift-Right>', extraRight)
    can.bind_all('<Shift-Left>', extraLeft)
    # Affichage du tableau de score
    label = Label(window,padx=50,pady=20,text='Votre score : ' + str(score) + ' points')
    label.grid(row=0,column=0)

window.mainloop()
